//
//  ViewController.swift
//  asdfasdfasdf
//
//  Created by Charles Srstka on 11/13/17.
//  Copyright © 2017 Charles Srstka. All rights reserved.
//

import Cocoa

class ViewController: NSViewController {
    @IBOutlet dynamic var treeController: NSTreeController!
    
    @objc dynamic var foo: String = "Foo"
    
    class Thingy: NSObject {
        @objc let name: String
        init(_ name: String) { self.name = name }
        @objc var children: [Thingy] { return [] }
    }
    
    @objc dynamic var thingies: [Thingy] = [Thingy("Foo"), Thingy("Bar")]
    
    @objc private static let keyPathsForValuesAffectingSelectionIndexPaths: Set<String> = [
        #keyPath(treeController.selectionIndexPaths),
        #keyPath(foo)
    ]
    @objc dynamic var selectionIndexPaths: [IndexPath] {
        return self.treeController.selectionIndexPaths
    }
    
    var observer1: NSKeyValueObservation? = nil
    var observer2: NSKeyValueObservation? = nil
    
    override func viewDidLoad() {
        super.viewDidLoad()

        self.observer1 = self.observe(\.selectionIndexPaths) { _, _ in
            print("This is only logged when foo changes")
        }
        
        self.observer2 = self.observe(\.treeController.selectionIndexPaths) { _, _ in
            print("This, however, is logged when the tree controller's selection changes")
        }
    }
    
    @IBAction func changeFoo(_: Any?) {
        self.foo = "Bar"
    }
}
